/*  *
 * ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code Shadows.com API client implementation.
 *
 * The Initial Developer of the Original Code is
 * Pluck Corporation. This code is Copyright (C) 2005, 2006
 * All Rights Reserved.
 *
 * Contributor(s):
 *   Carl Brown (carlb@shadows.com)
 *   Duane Fields (dfields@pluck.com)
 *
 * ***** END LICENSE BLOCK ***** */

/**
    Global variables and methods that pretty much everything needs
**/
debug ('contrib/shadows/common.js\n'); 
const PREF_DEBUG = "debug.enabled";
const WHY_CREATE_USER = "create user";
const WHY_BOOKMARKS = "bookmarks";
const WHY_COLLECTIONS = "collections";
const WHY_SHADOWPAGE = "shadowpage";

// assume we aren't testing if not set otherwise
if (typeof shadows.justTesting=="undefined") {
    shadows.justTesting=false;
}
if (typeof shadows.useLocalHostForTesting=="undefined") {
    shadows.useLocalHostForTesting=false;
}
if (typeof shadows.useBogusTimeoutHostForTesting=="undefined") {
    shadows.useBogusTimeoutHostForTesting=false;
}
if (typeof shadows.useBogusHostForTesting=="undefined") {
    shadows.useBogusHostForTesting=false;
}

shadows.isLoaded = function() {
    return true;
}

debug ('contrib/shadows/common.js: shadows.XmlRpc\n'); 

shadows.XmlRpc = {};
shadows.XmlRpc.Path = function() {
    if (shadows.justTesting==true) {
        if (shadows.useLocalHostForTesting==true) {
            return "http://localhost/api/rpc/open/";
        } else if (shadows.useBogusHostForTesting==true) {
            return "http://www.shadows.com/";
        } else if (shadows.useBogusTimeoutHostForTesting==true) {
            return "http://test.api.shadows.com:8008/api/rpc/open/";
        } else {
            return "http://test.api.shadows.com/api/rpc/open/";
        }
    } else {
        return "http://api.shadows.com/api/rpc/open/";
    }
}    
debug ('contrib/shadows/common.js: shadows.XmlRpc.Url\n'); 
shadows.XmlRpc.Url = function(why) {
    var value;
    switch(why) {
        // treat ints as strings so we can store LONGs
        case WHY_CREATE_USER:
            value = "createuser.rem";
            break;
        case WHY_BOOKMARKS:
            value = "authbookmark.rem";
            break;
        case WHY_COLLECTIONS:
            value = "authurlcollection.rem";
            break;
       case WHY_SHADOWPAGE:
            value = "public.rem";
            break;
        default:
            PluckDebug.fail("Unexpected reason to want shadows url");
    }
    //debug("Prefs: " + key + " = " + value);
    return shadows.XmlRpc.Path() + value;
}  
shadows.XmlRpc.timeout = 7;

debug ('contrib/shadows/common.js: secondsSinceEpoch\n'); 
// seconds since epoch
function secondsSinceEpoch () { return (new Date()).getTime()/1000; }
