function $(aID) { return document.getElementById(aID); }

var firstRunWizard = {};

firstRunWizard.load = function() {
    this.updateCommands();
    this.loadCurrentIndex();
    this.wizardRemoveClose();
}

firstRunWizard.close = function() {
    if (this.mIndex != this.mWizards.length - 1) {
        if (!this.save()) return;
    }

    window.close();
}

firstRunWizard.unload = function() {
   Components.classes['@mozilla.org/preferences-service;1']
    .getService(Components.interfaces.nsIPrefService).savePrefFile(null);
}


firstRunWizard.save = function() {
    for(var i = this.mIndex; i<this.mWizards.length; ++i) {
        if(this.mWizards[i].wizardSkip) {
            this.mWizards[i].wizardSkip();
        }
    }
    return true;
}

firstRunWizard.mWizards = new Array();
firstRunWizard.mIndex = 0;

firstRunWizard.finishCurrentPage = function() {
    if(firstRunWizard.mCommands.cmdNext.isEnabled()) {
        firstRunWizard.mCommands.cmdNext.exec();
    }
    else {
        firstRunWizard.close();
    }
}

firstRunWizard.getCookieString = function(aLocation) {
        var uri = Components.classes["@mozilla.org/network/standard-url;1"]
            .createInstance(Components.interfaces.nsIURI);
        var cservice = Components.classes["@mozilla.org/cookieService;1"]
            .getService().QueryInterface(Components.interfaces.nsICookieService);
        uri.spec = aLocation;

        result = cservice.getCookieString(uri, null);
        dump(result + "\n");
        if (!result) result = "";
        return result;
}

//can you tell...
firstRunWizard.loadCurrentIndexPart2 = function() {
    var innerWindow = $("frame").contentWindow;
    var currentWizard = firstRunWizard.mWizards[firstRunWizard.mIndex];
    $("frame").setAttribute("src", currentWizard.wizardURL);
    $("frame").src = currentWizard.wizardURL;
    innerWindow.addEventListener('load', firstRunWizard.loadCurrentIndexPart3, false);
}

firstRunWizard.wizardRemoveClose = function() {
    window.setTimeout(firstRunWizard.wizardRemoveClose,100);
    if(firstRunWizard.mInDelicatePhase) return;
    try {
        var innerWizard = $("frame").contentWindow.document.getElementsByTagName("wizard").item(0);
        if(innerWizard.onLastPage) {
            var cancel = innerWizard.getButton("cancel");
            cancel.setAttribute("hidden", true);
        }
    } catch(e) {}
}

firstRunWizard.wizardNext = function() {
}

//that this is a bit hacked...
firstRunWizard.loadCurrentIndexPart3 = function() {
    var innerWindow = $("frame").contentWindow;
    var currentWizard = firstRunWizard.mWizards[firstRunWizard.mIndex];
    innerWindow.arguments = currentWizard.wizardParameters;
    firstRunWizard.mInDelicatePhase = false;
    var innerWizard = $("frame").contentWindow.document.getElementsByTagName("wizard").item(0);
    if(innerWizard) {
//        innerWizard.addEventListener('wizardnext', firstRunWizard.wizardNext, false);
        //move around that cancel button
        var box = innerWizard.getButton("cancel").parentNode;
        box.insertBefore(innerWizard.getButton("cancel"), box.firstChild);
        var currentWizard = firstRunWizard.mWizards[firstRunWizard.mIndex];

        // update cancel with our own label
        if (currentWizard == WizardStart) {
          innerWizard.getButton("cancel").setAttribute("label", "Skip Setup");
        } else {
          innerWizard.getButton("cancel").setAttribute("label", 
            $("messages").getAttribute("skipMessage").replace(/%wizard/,currentWizard.wizardName));
        }
        innerWizard.getButton("finish").addEventListener('command', firstRunWizard.finishCurrentPage, false);

        innerWizard.getButton("finish").setAttribute("label", 
            $("messages").getAttribute("finishMessage"));

        // add our own event listeners.  may generalize this later
        if(firstRunWizard.mIndex==0) {
        }
        else {
            innerWizard.getButton("cancel")
                .addEventListener('command', firstRunWizard.finishCurrentPage, false);
        }
    }
    else {
        window.setTimeout("firstRunWizard.loadCurrentIndexPart3()", 50);
    }
}

firstRunWizard.loadCurrentIndex = function() {
    firstRunWizard.mInDelicatePhase = true;
    var innerWindow = $("frame").contentWindow;
    var currentWizard =  firstRunWizard.mWizards[firstRunWizard.mIndex];
    $("frame").setAttribute("src", "");
    $("frame").src = "";
    window.setTimeout("firstRunWizard.loadCurrentIndexPart2()", 50);
}

firstRunWizard.registerSubWizard = function(aSubWizard) {
    this.mWizards.push(aSubWizard);
}

firstRunWizard.advancePage = function(aOffset) {
    this.mIndex += aOffset;
    while(this.mIndex>0 && this.mIndex<this.mWizards.length) {
        if(!this.mWizards[this.mIndex].wizardEnabled) {
            if(this.mWizards[this.mIndex].wizardSkip) {
                this.mWizards[this.mIndex].wizardSkip();
            }
            this.advancePage(aOffset);
            return;
        }
        break;
    }
    firstRunWizard.loadCurrentIndex();
}

firstRunWizard.getWizardName = function(aID) {
    return $("wizardNames").getAttribute(aID);
}

firstRunWizard.getCheckboxLabel = function(aID) {
    return $("wizardCheckboxLabels").getAttribute(aID);
}

/////////////////////////////////////////////////////////////////////////////////////
// Command stuff
/////////////////////////////////////////////////////////////////////////////////////
firstRunWizard.mCommands = {};
firstRunWizard.mCommands.cmdNext = {
    isEnabled: function() {
        return (firstRunWizard.mIndex!=firstRunWizard.mWizards.length-1);
    },
    exec: function() {
        firstRunWizard.advancePage(1);
    },
};

firstRunWizard.mCommands.cmdPrev = {
    isEnabled: function() {
        return (firstRunWizard.mIndex!=0);
    },
    exec: function() {
        firstRunWizard.advancePage(-1);
    },
};

firstRunWizard.updateCommands = function() {
    var commands = $("firstRunWizardCommands");
    for(var i = 0;i<commands.childNodes.length;++i) {
        var command = commands.childNodes.item(i);
        var id = command.getAttribute("id");
        if(firstRunWizard.mCommands[id]) {
            if(firstRunWizard.mCommands[id].isEnabled()) {
                $(id).removeAttribute("disabled");
            }
            else {
                $(id).setAttribute("disabled", true);
            }
        }
    }
}

firstRunWizard.doCommand = function(aID) {
    firstRunWizard.mCommands[aID].exec();
    firstRunWizard.updateCommands();
}

/////////////////////////////////////////////////////////////////////////////////////
// Specific Pages
/////////////////////////////////////////////////////////////////////////////////////

var WizardStart = {
    wizardURL: "chrome://fbranding/content/firstRunWizardStart.xul",
    wizardName: firstRunWizard.getWizardName("start"),
    wizardLabel: firstRunWizard.getCheckboxLabel("start"),
    wizardEnabled: true,
    wizardParameters: [firstRunWizard],
    internal: true,
}


var FlashFirstRun = {
    wizardURL: "chrome://mozapps/content/plugins/pluginInstallerWizard.xul",
    wizardParameters: null,
    wizardName: firstRunWizard.getWizardName("flash"),
    wizardLabel: firstRunWizard.getCheckboxLabel("flash"),
    wizardEnabled: false,
    internal: true,
    init: function() {
        var flash = "application/x-shockwave-flash";
        var missingPluginsArray = new Object;
        var pluginInfo = {mimetype: flash, pluginsPage: "about:blank"};
        missingPluginsArray[pluginInfo.mimetype] = pluginInfo;
        this.wizardParameters = [{plugins: missingPluginsArray, tab: null}];
        if(!this.hasFlash()) {
            this.wizardEnabled = true;
        }
    },
    hasFlash: function() {
        var flashinstalled = 0;
        var flashversion = 0;
        if(navigator.plugins && navigator.plugins.length)
        {
            x = navigator.plugins["Shockwave Flash"];
            if(x){
                flashinstalled = 2;
                if (x.description) {
                    y = x.description;
                    flashversion = y.charAt(y.indexOf('.')-1);
                }
            }
            else {
                flashinstalled = 1;
            }
            if(navigator.plugins["Shockwave Flash 2.0"]) {
                flashinstalled = 2;
                flashversion = 2;
            }
        }
        else if(navigator.mimeTypes && navigator.mimeTypes.length)
        {
            x = navigator.mimeTypes['application/x-shockwave-flash'];
            if(x && x.enabledPlugin) {
                flashinstalled = 2;
            }
            else{
                flashinstalled = 1;
            }
        }
        return (flashinstalled==2);
    },
}

FlashFirstRun.init();

var PhotoFirstRun = {
    wizardURL: "chrome://browser/content/flock/photo/photoAccountWizard.xul",
    wizardParameters: [],
    wizardName: firstRunWizard.getWizardName("photo"),
    wizardLabel: firstRunWizard.getCheckboxLabel("photo"),
    wizardEnabled: false,
    init: function() {
        var params = {};
        params["autoImport"] = true;
        this.wizardParameters[0] = params;
    },
}
PhotoFirstRun.init();


var FlickrFirstRun = {
    wizardURL: "chrome://browser/content/flock/photo/photoAccountWizard.xul",
    wizardParameters: ["flickr"],
    wizardName: firstRunWizard.getWizardName("flickr"),
    wizardLabel: firstRunWizard.getCheckboxLabel("flickr"),
    wizardEnabled: false,
    init: function() {
        var cookieString = firstRunWizard.getCookieString("http://flickr.com");
        if(!cookieString) cookieString = firstRunWizard.getCookieString("http://www.flickr.com");
        if(!cookieString) return;
        if(
            cookieString.match(/cookie_epass/) ||
            cookieString.match(/cookie_session/)
            ) {
            this.wizardEnabled = true;
            PhotoFirstRun.wizardEnabled = true;
        }
    },
}

FlickrFirstRun.init();

var PhotobucketFirstRun = {
    wizardURL: "chrome://browser/content/flock/photo/photoAccountWizard.xul",
    wizardParameters: ["photobucket"],
    wizardName: firstRunWizard.getWizardName("photobucket"),
    wizardLabel: firstRunWizard.getCheckboxLabel("photobucket"),
    wizardEnabled: false,
    init: function() {
        var cookieString = firstRunWizard.getCookieString("http://photobucket.com");
        if(!cookieString) return;
        if(
            cookieString.match(/pbusername/) ||
            cookieString.match(/utm/)
            ) {
            this.wizardEnabled = true;
            PhotoFirstRun.wizardEnabled = true;
        }
    },
}

PhotobucketFirstRun.init();

var WizardEnd = {
    wizardURL: "chrome://fbranding/content/firstRunWizardEnd.xul",
    wizardParameters: null,
    wizardName: "Flock Wizard End",
    wizardEnabled: true,
    internal: true,
    wizardParameters: [firstRunWizard],
}

var BlogFirstRun = {
    wizardURL: "chrome://browser/content/flock/blog/blogAccountWizard.xul",
    wizardParameters: null,
    wizardName: firstRunWizard.getWizardName("blog"),
    wizardLabel: firstRunWizard.getCheckboxLabel("blog"),
    wizardEnabled: false,
}

var FavoritesFirstRun = {
    wizardURL: "chrome://browser/content/flock/favorites/favoritesSharing.xul",
    wizardParameters: ['firstrun'],
    wizardName: firstRunWizard.getWizardName("favorites"),
    wizardLabel: firstRunWizard.getCheckboxLabel("favorites"),
    wizardEnabled: false,
}

var FeedFirstRun = {
    wizardURL: "chrome://browser/content/flock/feed/feedFirstRun.xul",
    wizardParameters: null,
    wizardName: firstRunWizard.getWizardName("feed"),
    wizardLabel: firstRunWizard.getCheckboxLabel("feed"),
    wizardEnabled: true,
    wizardSkip: function() {
        // load first feed no matter what
        var key = "feeds.bundles.urls_0";
        var url = $("strings").getString(key);
        feedUtils.loadFeedFromLocalOPML(url);
    },
}

var SearchFirstRun = {
    wizardURL: "chrome://browser/content/flock/lucene/searchSetupWizard.xul",
    wizardParameters: null,
    wizardName: firstRunWizard.getWizardName("search"),
    wizardLabel: firstRunWizard.getCheckboxLabel("search"),
    wizardEnabled: true,
}

firstRunWizard.registerSubWizard(WizardStart);
//firstRunWizard.registerSubWizard(FlickrFirstRun);
//firstRunWizard.registerSubWizard(PhotobucketFirstRun);
firstRunWizard.registerSubWizard(SearchFirstRun);
firstRunWizard.registerSubWizard(PhotoFirstRun);
firstRunWizard.registerSubWizard(BlogFirstRun);
firstRunWizard.registerSubWizard(FavoritesFirstRun);
firstRunWizard.registerSubWizard(FeedFirstRun);
firstRunWizard.registerSubWizard(FlashFirstRun);
firstRunWizard.registerSubWizard(WizardEnd);
