/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is SpellBound code.
 *
 * The Initial Developer of the Original Code is
 * Robert Strong <moz@exchangecode.com>.
 * Portions created by the Initial Developer are Copyright (C) 2004-2005
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var gOrigLang = "";
var gEditor;
var gEditorElement;

function prefsDlgInit() {
  document.getElementById("editorWrap").checked = getSBPrefs().getBoolPref("editor.display.wrap", 160);
  document.getElementById("misspelled.fontWeight").checked = getSBPrefs().getBoolPref("editor.misspelled.display.bold", false);
  document.getElementById("misspelled.fontStyle").checked = getSBPrefs().getBoolPref("editor.misspelled.display.italic", false);
  document.getElementById("misspelled.underline").checked = getSBPrefs().getBoolPref("editor.misspelled.display.underline", true);
  document.getElementById("misspelledEnable").checked = getSBPrefs().getBoolPref("editor.misspelled.enabled", true);

  toggleMisspell();

  var nHeight = getSBPrefs().getIntPref("editor.height", 160);
  var menuListEditorHeight = document.getElementById("editorHeight");
  menuListEditorHeight.removeChild(menuListEditorHeight.firstChild);
  menuListEditorHeight.appendChild(document.createElement("menupopup"));

  for (var i = 3; i < 21; i++)
    menuListEditorHeight.appendItem((i * 20), i * 20);

  var nIndex = FindIndex(menuListEditorHeight.childNodes[0], "value", nHeight);
  if(nIndex > -1)
    menuListEditorHeight.selectedIndex = nIndex;
  else
    menuListEditorHeight.selectedIndex = 4;

  initEditor();

  // init color values
  document.getElementById("foregroundText").setAttribute("value",
      getSBPrefs().getCharPref("editor.display.foreground_color", "#000000"));
  document.getElementById("background").setAttribute("value",
      getSBPrefs().getCharPref("editor.display.background_color", "#FFFFFF"));
  document.getElementById("misspelledForegroundText").setAttribute("value",
      getSBPrefs().getCharPref("editor.misspelled.display.foreground_color", "#FF0000"));
  document.getElementById("misspelledBackground").setAttribute("value",
      getSBPrefs().getCharPref("editor.misspelled.display.background_color", "#FFFFFF"));

  // set colorpicker elements
  getColorFromWellAndSetValue("foregroundtextmenu");
  getColorFromWellAndSetValue("backgroundmenu");
  getColorFromWellAndSetValue("misspelledforegroundtextmenu");
  getColorFromWellAndSetValue("misspelledbackgroundmenu");

  // complete hack to try to make the left and right
  // sections the same size in any locale.
  var sLeft = document.getElementById("normalText").getAttribute("label");
  var sRight = document.getElementById("misspelledEnable").getAttribute("label");
  var boxWidth;
  if(sRight.length > sLeft.length)
    boxWidth = sRight.length * 7;
  else
    boxWidth = sLeft.length * 7;

  document.getElementById("pageColours").setAttribute("style", "min-width:" + boxWidth + "px;");
  document.getElementById("misspelledPageColours").setAttribute("style", "min-width:" + boxWidth + "px;");

  var head = gEditor.document.getElementsByTagName("HEAD");
  var style = gEditorElement.contentWindow.document.createElement("style");
  style.setAttribute("type", "text/css");
  style.setAttribute("id", "spellbound_style");
  style.innerHTML = getStyleRules();
  head[0].appendChild(style);
  gEditor.rootElement.innerHTML = document.getElementById("normalText").getAttribute("label") +
      " <span _moz_misspelled='true'>" + document.getElementById("misspelledEnable").getAttribute("label") +
      "</span><br /> 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0";

  setEditorHeight();

  if(gDialog.LanguageMenulist.firstChild.childNodes.length == 2)
    if(confirm(document.getElementById("downloadDictionaries").getAttribute("label")))
      window.opener.openDialog(getBrowserURL(), "_blank", "chrome,all,dialog=no",
          "http://dictionaries.mozdev.org/installation.html");
}

function prefsSaveSettings() {
  getSBPrefs().setIntPref("editor.height", document.getElementById("editorHeight").value);
  getSBPrefs().setBoolPref("editor.display.wrap", document.getElementById("editorWrap").checked);
  getSBPrefs().setBoolPref("editor.misspelled.enabled", document.getElementById("misspelledEnable").checked);
  getSBPrefs().setBoolPref("editor.misspelled.display.bold", document.getElementById("misspelled.fontWeight").checked);
  getSBPrefs().setBoolPref("editor.misspelled.display.italic", document.getElementById("misspelled.fontStyle").checked);
  getSBPrefs().setBoolPref("editor.misspelled.display.underline", document.getElementById("misspelled.underline").checked);
  getSBPrefs().setCharPref("editor.display.foreground_color", document.getElementById("foregroundText").getAttribute("value"));
  getSBPrefs().setCharPref("editor.display.background_color", document.getElementById("background").getAttribute("value"));
  getSBPrefs().setCharPref("editor.misspelled.display.foreground_color", document.getElementById("misspelledForegroundText").getAttribute("value"));
  getSBPrefs().setCharPref("editor.misspelled.display.background_color", document.getElementById("misspelledBackground").getAttribute("value"));
  onClose();
}

function prefsDoCancel() {
  if (gOrigLang && gOrigLang != "")
    gSpellChecker.SetCurrentDictionary(gOrigLang);
  onClose();
}

function initEditor()
{
  gEditorElement = document.getElementById("content-frame");
  try {
    gEditorElement.makeEditable('htmlmail',false);
  } catch (e) {
    alert("Unable to setup editor!\n\nPossible solution:\nReinstall the SpellBound libraries.");
    dump("*** Exception error: makeEditable!!!\n" + e);
    return;
  }
  gEditor = gEditorElement.getEditor(gEditorElement.contentWindow);
  gEditor.QueryInterface(Components.interfaces.nsIEditorMailSupport);
  gEditor.QueryInterface(Components.interfaces.nsIPlaintextEditor);
  gEditor.QueryInterface(Components.interfaces.nsIHTMLEditor);
  gEditor.enableUndo(false);

  // Get the spellChecker shell
  gSpellChecker = Components.classes['@mozilla.org/editor/editorspellchecker;1'].createInstance(Components.interfaces.nsIEditorSpellCheck);
  if (!gSpellChecker)
  {
    alert("Unable to setup the SpellChecker!\n\nPossible solution:\nReinstall the SpellBound libraries.");
    dump("*** Exception error: nsIEditorSpellCheck!!!\n");
    window.close();
    return;
  }

  // Start the spell checker module.
  try {
    // TxtSrv Filter Contract Id
    var filterContractId = "@mozilla.org/editor/txtsrvfiltermail;1";
    gSpellChecker.setFilter(Components.classes[filterContractId].createInstance(Components.interfaces.nsITextServicesFilter));
    gSpellChecker.InitSpellChecker(gEditor, true);
  }
  catch (e) {
    alert("Unable to setup the SpellChecker!\n\nPossible solution:\nReinstall the SpellBound libraries.");
    dump("*** Exception error: InitSpellChecker\n" + e);
    window.close();
    return;
  }

  try {
    gOrigLang = gSpellChecker.GetCurrentDictionary();
  } catch (e) { }
  gDialog.LanguageMenulist = document.getElementById("LanguageMenulist");
  InitLanguageMenu(gOrigLang);
}

function setStyle() {
  var elem = gEditor.document.getElementById("spellbound_style");
  if(elem)
    elem.innerHTML = getStyleRules();
}

function setEditorHeight() {
  document.getElementById("appcontent").setAttribute("height", document.getElementById("editorHeight").value + "px");
  window.sizeToContent();
}

function toggleMisspell() {
  SetElementEnabledById("misspelled.fontWeight", document.getElementById("misspelledEnable").checked);
  SetElementEnabledById("misspelled.fontStyle", document.getElementById("misspelledEnable").checked);
  SetElementEnabledById("misspelled.underline", document.getElementById("misspelledEnable").checked);
  SetElementEnabledById("misspelledColorFG", document.getElementById("misspelledEnable").checked);
  SetElementEnabledById("misspelledColorBG", document.getElementById("misspelledEnable").checked);
  // use visibility:hidden otherwise the widget collapses and other widgets reposition themselves
  SetElementVisibleById("misspelledforegroundtextmenu", document.getElementById("misspelledEnable").checked);
  SetElementVisibleById("misspelledbackgroundmenu", document.getElementById("misspelledEnable").checked);
}

function FindIndex(arrayname,searchin,searchfor) {
  // This is to set the selectedIndex of something to whatever the first thing that matches the tag is. Very handy.
  for (var i=0;i<arrayname.childNodes.length;i++) {
    if (arrayname.childNodes[i].getAttribute(searchin) == searchfor) {
      return i;
      break;
    }
  }
  return -1;
}

function getStyleRules() {
  var rules = "body {\n" +
            "  font-family: -moz-fixed;\n" +
            "  margin: 0 2px 0 2px;\n";

  if(!document.getElementById("editorWrap").checked)
    rules += "  white-space: nowrap;\n";

  rules += "  color: " + document.getElementById("foregroundText").getAttribute("value") + ";\n";
  rules += "  background-color: " + document.getElementById("background").getAttribute("value") + ";\n";
  rules += "}\n";

  if(document.getElementById("misspelledEnable").checked) {
    rules += "\nspan[_moz_misspelled='true'] {\n";
    rules += "  color: " + document.getElementById("misspelledForegroundText").getAttribute("value") + ";\n";

    if(document.getElementById("misspelled.underline").checked)
      rules += "  background: url(chrome://spellbound/skin/underlines/" +
               document.getElementById("misspelledForegroundText").getAttribute("value").substring(1).toLowerCase() +
               ".gif) repeat-x 100% 80%;\n" +
               "  padding-bottom: 4px;\n";

    rules += "  background-color: " + document.getElementById("misspelledBackground").getAttribute("value") + ";\n";

    if(document.getElementById("misspelled.fontWeight").checked)
      rules += "  font-weight: bold;\n";

    if(document.getElementById("misspelled.fontStyle").checked)
      rules += "  font-style: italic;\n";

    rules += "}\n";
  }
  return rules;
}

// from the Mozilla prefs code
function setColorWell(aPicker) {
  var colorRef = aPicker.nextSibling;                // colour value is held here
  colorRef.setAttribute("value", aPicker.color);
}

// from the Mozilla prefs code
function getColorFromWellAndSetValue(aPickerId) {
  var picker = document.getElementById(aPickerId);
  var colorRef  = picker.nextSibling;
  var color = colorRef.getAttribute("value");
  picker.color = color;
  return color;
}
